=============================================================================
revision 1.8
date: 2005/01/25 19:32:14;  author: mgr;  state: Exp;  lines: +115 -62
Until now the animation was twisted. That is it "flew" from botten to
top and the amplitudes of the bars were displayed horizontally. This
was the easiest way that resulted in the way the string that is sent
to the cube is interpreted by the latter.

To change this behaviour the cube_string is reintroduced (and for the
first time it is actually called by this name in the source code).

The plains of the cube[5][26]-array are no longer written directly to
the tty device file as described in the changelog entry of the
previous revision but first put into the cube_string (an array of the
length 126), this string is than permutated and the resulting string
(straightforwardly called the permutated_cube_string) is subsequently
written to the tty device file.

The permutation is specified by the permutation-array, the actual
content of which has previously been calculated by some nifty Common
Lisp code..

The xscale-array (cp. log entry of revision 1.4) has been changed to
create a "more active" LED-flashing. This has to be changed with more
thought in the future. The current content is obtained by experiment:
"Hm, let's change this value.. Oh, see, it looks more nice!"

In front of the formerly leading comment paragraph there is a new one
that describes what the Cube Analyzer is all about. Right now this is
the same text as in the description of the RCS-file. The text in the
about window has been changed to an almost identical text.
----------------------------
revision 1.7
date: 2005/01/24 23:27:26;  author: mgr;  state: Exp;  lines: +26 -16
Until this version each of the five plains of the cube displayed the
qsame spectrum analysis. To change this quite prosy behavior a new
representation of the cube is introduced in this version: the
character array cube[5][26]; it represents the five plains with 25
LEDs each (the length is 26 because of the zero termination).

To actually use it the characters that specify each LEDs state are not
directly written to a cube_string anymore but to the cube[5][26]-array.
This array is than written to the tty device file by the following
command:

     fprintf(ttyfile, "%s%s%s%s%s\n\n", cube[0], cube[1], cube[2],
                                                 cube[3], cube[4]);

As the cube has always to receive a 125 characters long string and the
25 characters of each plain-representing string in the cube[5][26]-array
are defined by direct array access in cube_write_func, the zero
termination of the 5 strings is always in the last array element, and
therefore one has to do this only once.  This happens in the function
cube_analyzer_init.

To actually introduce a hopefully comely effect the spectrum analysis
is only written to the zeroth plain. Before this the first plain has
been filled with the previous content of the zeroth plain, the second
one with the previous content of the first one, and so on. In other
words: Now the cube displays the temporal course of the frequency
spectrum (of a short time period).
----------------------------
revision 1.6
date: 2005/01/24 18:52:58;  author: mgr;  state: Exp;  lines: +11 -12
The only changes are in the function cube-write_func: The characters
to switch the LEDs on or off are no longer directly written to the tty
device file, but first put into a character array (that is called the
"cube string" in later versions) and subsequently written to the tty
device file in one go.
----------------------------
revision 1.5
date: 2005/01/24 11:06:46;  author: mgr;  state: Exp;  lines: +7 -7
Now the cube analyzer code is disembodied from the xmms source package.
(Formerly it was located .xmms-1.2.10/Visualization/cube_analyzer/;
only on my local hard disk, of course.) Therefore the needed files for
the GNU automake suite (aclocal, autoheader, automake, and autoconf)
were created, ea sunt Makefile.am and configure.in. (By the way, I have
been using automake version 1.4.)

[ Therby the "XMMS Plugin tutorial at nobugs.org" (located at
  http://www.xmms.org/docs/vis-plugin.html and
  http://www.nobugs.org/developer/xmms/xmms-nobugs.html) was quite
  useful. (In general I do not want to recommend that tutorial. It
  does not really explain "how things work", i.e. what kind of data
  xmms provides etc. If you want to write your first visualization
  plug-in you should perhaps look for a tutorial that does not use
  SDL, OpenGL, and threading.) ]
----------------------------
revision 1.4
date: 2005/01/24 09:45:46;  author: mgr;  state: Exp;  lines: +117 -71
The first version that actually writes to the real LED cube (this
happens in the function cube_write_func). This is a very simple hack
as for each step of each band the corresponding character is directly
written to the tty device file. (The file is flushed near the end of
cube_write_func.)

A delay is needed between each writing of the LED cube as the cube is
not fast enough to be written as often as XMMS calls
cube_analyzer_render_freq (the function that calls cube_write_func).
As using a threaded model would perhaps be unnecessarily complex
there is a simple delay counter that does the writing only every
TTY_DELAY_LOOPS times.

xscale is the array that specifies how the 256 frequency bands XMMS
hands over are "compressed" to only NUM_BANDS bands. For each band
you have to specify a range, therefore xscale actually encompasses
(NUM_BANDS + 1) values. Anyway, now xscale has only 6 values instead
of the original 17, as it has to be for our 5 bands.

NUM_STEPS represts the number of steps/levels that each bar can
have. In the spectrum analyzer X window each step has a height
of (HEIGHT / NUM_STEPS) whereat HEIGHT is the height of the X
window. Looking at the real LED cube each step is represented by
an LED, of course.

The superfluous directory browser ("dirbrowser") is removed from the
configuration dialog. (A pure _directory_ browser is useless if you
have to select a _file_. A file browser is unnecessary as well in my
opinion. Hey, you just have to specify the tty device file..)

An about window is added. The code is shamelessly taken from the OSS
output plug-in of the XMMS source code package.
cp. xmms-1.2.10/Output/OSS/about.c
----------------------------
revision 1.3
date: 2005/01/23 23:47:02;  author: mgr;  state: Exp;  lines: +183 -25
I've included the configuration dialog from the disk_writer output plug-in of the XMMS source code package.
The directory browser ("dirbrowser") is still included.
cp. xmms-1.2.10/Output/disk_writer/disk_writer.c
----------------------------
revision 1.2
date: 2000/07/31 21:41:05;  author: mgr;  state: Exp;  lines: +244 -0
This is not really the Cube Analyzer but the file spectrum.c of sanalyzer,
i.e. the code I started with.
----------------------------
revision 1.1
date: 2005/01/25 19:55:58;  author: mgr;  state: Exp;
Initial revision
=============================================================================
